/**
 *
 *  Class ConstraintDiagramsEvaluateAllVisitor.java
 *
 *  Generated by KMFStudio at 28 April 2003 19:17:20
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams;

import java.util.*;

import uk.ac.ukc.cs.kmf.util.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Parser.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Bridge.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.*;

import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Spider;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ArrowEnd;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ContourKind;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.SpiderKind;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.CollectionKind;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour;

public class ConstraintDiagramsEvaluateAllVisitor$Class
	extends ConstraintDiagramsVisitor$Class
	implements ConstraintDiagramsEvaluateAllVisitor
{
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv range_bidirectional: Set{range}->forAll(x | x.rangeOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t1 = OCL.Set();
			Collection_ t2 = (Collection_)self.getRange();
			t1 = t1.including(t2);
			Collection_ x = null;
			IOclBoolean t3 = OCL.Boolean(true);
			java.util.Iterator t4 = OCL.impl(t1).iterator();
			while (t4.hasNext()) {
			    x = (Collection_)t4.next();
			    IOclSet t5 = OCL.Set(x.getRangeOf());
			    IOclBoolean t6 = (IOclBoolean)t5.includes(self);
			    t3 = t6;
			    if(!OCL.impl(t3)) break;
			}
			log.reportMessage(": "+t3);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv restriction_size: 0<=restriction->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t7 = OCL.Set(self.getRestriction());
			IOclInteger t8 = (IOclInteger)t7.size();
			IOclBoolean t9 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t8);
			log.reportMessage(": "+t9);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv restriction_bidirectional: restriction->forAll(x | x.restrictedProperty->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t10 = OCL.Set(self.getRestriction());
			RelationRestriction x = null;
			IOclBoolean t11 = OCL.Boolean(true);
			java.util.Iterator t12 = OCL.impl(t10).iterator();
			while (t12.hasNext()) {
			    x = (RelationRestriction)t12.next();
			    IOclSet t13 = OCL.Set(x.getRestrictedProperty());
			    IOclBoolean t14 = (IOclBoolean)t13.includes(self);
			    t11 = t14;
			    if(!OCL.impl(t11)) break;
			}
			log.reportMessage(": "+t11);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv domain_bidirectional: Set{domain}->forAll(x | x.domainOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t15 = OCL.Set();
			Collection_ t16 = (Collection_)self.getDomain();
			t15 = t15.including(t16);
			Collection_ x = null;
			IOclBoolean t17 = OCL.Boolean(true);
			java.util.Iterator t18 = OCL.impl(t15).iterator();
			while (t18.hasNext()) {
			    x = (Collection_)t18.next();
			    IOclSet t19 = OCL.Set(x.getDomainOf());
			    IOclBoolean t20 = (IOclBoolean)t19.includes(self);
			    t17 = t20;
			    if(!OCL.impl(t17)) break;
			}
			log.reportMessage(": "+t17);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv rangeOf_size: 0<=rangeOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t21 = OCL.Set(self.getRangeOf());
			IOclInteger t22 = (IOclInteger)t21.size();
			IOclBoolean t23 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t22);
			log.reportMessage(": "+t23);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv rangeOf_bidirectional: rangeOf->forAll(x | x.range=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t24 = OCL.Set(self.getRangeOf());
			Relation x = null;
			IOclBoolean t25 = OCL.Boolean(true);
			java.util.Iterator t26 = OCL.impl(t24).iterator();
			while (t26.hasNext()) {
			    x = (Relation)t26.next();
			    Collection_ t27 = (Collection_)x.getRange();
			    IOclBoolean t28 = OCL.equalTo(t27, self);
			    t25 = t28;
			    if(!OCL.impl(t25)) break;
			}
			log.reportMessage(": "+t25);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv domainOf_size: 0<=domainOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t29 = OCL.Set(self.getDomainOf());
			IOclInteger t30 = (IOclInteger)t29.size();
			IOclBoolean t31 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t30);
			log.reportMessage(": "+t31);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv domainOf_bidirectional: domainOf->forAll(x | x.domain=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t32 = OCL.Set(self.getDomainOf());
			Relation x = null;
			IOclBoolean t33 = OCL.Boolean(true);
			java.util.Iterator t34 = OCL.impl(t32).iterator();
			while (t34.hasNext()) {
			    x = (Relation)t34.next();
			    Collection_ t35 = (Collection_)x.getDomain();
			    IOclBoolean t36 = OCL.equalTo(t35, self);
			    t33 = t36;
			    if(!OCL.impl(t33)) break;
			}
			log.reportMessage(": "+t33);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv region_size: 0<=region->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t37 = OCL.Set(self.getRegion());
			IOclInteger t38 = (IOclInteger)t37.size();
			IOclBoolean t39 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t38);
			log.reportMessage(": "+t39);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv region_bidirectional: region->forAll(x | x.collection=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t40 = OCL.Set(self.getRegion());
			Region x = null;
			IOclBoolean t41 = OCL.Boolean(true);
			java.util.Iterator t42 = OCL.impl(t40).iterator();
			while (t42.hasNext()) {
			    x = (Region)t42.next();
			    Collection_ t43 = (Collection_)x.getCollection();
			    IOclBoolean t44 = OCL.equalTo(t43, self);
			    t41 = t44;
			    if(!OCL.impl(t41)) break;
			}
			log.reportMessage(": "+t41);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Spider' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Spider self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ArrowEnd' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ArrowEnd self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv range_bidirectional: Set{range}->forAll(x | x.rangeOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t45 = OCL.Set();
			Collection_ t46 = (Collection_)self.getRange();
			t45 = t45.including(t46);
			Collection_ x = null;
			IOclBoolean t47 = OCL.Boolean(true);
			java.util.Iterator t48 = OCL.impl(t45).iterator();
			while (t48.hasNext()) {
			    x = (Collection_)t48.next();
			    IOclSet t49 = OCL.Set(x.getRangeOf());
			    IOclBoolean t50 = (IOclBoolean)t49.includes(self);
			    t47 = t50;
			    if(!OCL.impl(t47)) break;
			}
			log.reportMessage(": "+t47);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restriction_size: 0<=restriction->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t51 = OCL.Set(self.getRestriction());
			IOclInteger t52 = (IOclInteger)t51.size();
			IOclBoolean t53 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t52);
			log.reportMessage(": "+t53);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restriction_bidirectional: restriction->forAll(x | x.restrictedProperty->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t54 = OCL.Set(self.getRestriction());
			RelationRestriction x = null;
			IOclBoolean t55 = OCL.Boolean(true);
			java.util.Iterator t56 = OCL.impl(t54).iterator();
			while (t56.hasNext()) {
			    x = (RelationRestriction)t56.next();
			    IOclSet t57 = OCL.Set(x.getRestrictedProperty());
			    IOclBoolean t58 = (IOclBoolean)t57.includes(self);
			    t55 = t58;
			    if(!OCL.impl(t55)) break;
			}
			log.reportMessage(": "+t55);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv domain_bidirectional: Set{domain}->forAll(x | x.domainOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t59 = OCL.Set();
			Collection_ t60 = (Collection_)self.getDomain();
			t59 = t59.including(t60);
			Collection_ x = null;
			IOclBoolean t61 = OCL.Boolean(true);
			java.util.Iterator t62 = OCL.impl(t59).iterator();
			while (t62.hasNext()) {
			    x = (Collection_)t62.next();
			    IOclSet t63 = OCL.Set(x.getDomainOf());
			    IOclBoolean t64 = (IOclBoolean)t63.includes(self);
			    t61 = t64;
			    if(!OCL.impl(t61)) break;
			}
			log.reportMessage(": "+t61);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restrictedProperty_size: 1<=restrictedProperty->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t65 = OCL.Set(self.getRestrictedProperty());
			IOclInteger t66 = (IOclInteger)t65.size();
			IOclBoolean t67 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t66);
			log.reportMessage(": "+t67);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restrictedProperty_bidirectional: restrictedProperty->forAll(x | x.restriction->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t68 = OCL.Set(self.getRestrictedProperty());
			Relation x = null;
			IOclBoolean t69 = OCL.Boolean(true);
			java.util.Iterator t70 = OCL.impl(t68).iterator();
			while (t70.hasNext()) {
			    x = (Relation)t70.next();
			    IOclSet t71 = OCL.Set(x.getRestriction());
			    IOclBoolean t72 = (IOclBoolean)t71.includes(self);
			    t69 = t72;
			    if(!OCL.impl(t69)) break;
			}
			log.reportMessage(": "+t69);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv arrow_size: 0<=arrow->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t73 = OCL.Set(self.getArrow());
			IOclInteger t74 = (IOclInteger)t73.size();
			IOclBoolean t75 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t74);
			log.reportMessage(": "+t75);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv arrow_bidirectional: arrow->forAll(x | x.restriction=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t76 = OCL.Set(self.getArrow());
			Arrow x = null;
			IOclBoolean t77 = OCL.Boolean(true);
			java.util.Iterator t78 = OCL.impl(t76).iterator();
			while (t78.hasNext()) {
			    x = (Arrow)t78.next();
			    RelationRestriction t79 = (RelationRestriction)x.getRestriction();
			    IOclBoolean t80 = OCL.equalTo(t79, self);
			    t77 = t80;
			    if(!OCL.impl(t77)) break;
			}
			log.reportMessage(": "+t77);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ContourKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ContourKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Arrow inv restriction_bidirectional: Set{restriction}->forAll(x | x.arrow->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t81 = OCL.Set();
			RelationRestriction t82 = (RelationRestriction)self.getRestriction();
			t81 = t81.including(t82);
			RelationRestriction x = null;
			IOclBoolean t83 = OCL.Boolean(true);
			java.util.Iterator t84 = OCL.impl(t81).iterator();
			while (t84.hasNext()) {
			    x = (RelationRestriction)t84.next();
			    IOclSet t85 = OCL.Set(x.getArrow());
			    IOclBoolean t86 = (IOclBoolean)t85.includes(self);
			    t83 = t86;
			    if(!OCL.impl(t83)) break;
			}
			log.reportMessage(": "+t83);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Arrow inv diagram_bidirectional: Set{diagram}->forAll(x | x.arrow->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t87 = OCL.Set();
			Diagram t88 = (Diagram)self.getDiagram();
			t87 = t87.including(t88);
			Diagram x = null;
			IOclBoolean t89 = OCL.Boolean(true);
			java.util.Iterator t90 = OCL.impl(t87).iterator();
			while (t90.hasNext()) {
			    x = (Diagram)t90.next();
			    IOclSet t91 = OCL.Set(x.getArrow());
			    IOclBoolean t92 = (IOclBoolean)t91.includes(self);
			    t89 = t92;
			    if(!OCL.impl(t89)) break;
			}
			log.reportMessage(": "+t89);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv spider_size: 0<=spider->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t93 = OCL.Set(self.getSpider());
			IOclInteger t94 = (IOclInteger)t93.size();
			IOclBoolean t95 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t94);
			log.reportMessage(": "+t95);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv contour_size: 1<=contour->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t96 = OCL.Set(self.getContour());
			IOclInteger t97 = (IOclInteger)t96.size();
			IOclBoolean t98 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t97);
			log.reportMessage(": "+t98);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv contour_bidirectional: contour->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t99 = OCL.Set(self.getContour());
			Contour x = null;
			IOclBoolean t100 = OCL.Boolean(true);
			java.util.Iterator t101 = OCL.impl(t99).iterator();
			while (t101.hasNext()) {
			    x = (Contour)t101.next();
			    Diagram t102 = (Diagram)x.getDiagram();
			    IOclBoolean t103 = OCL.equalTo(t102, self);
			    t100 = t103;
			    if(!OCL.impl(t100)) break;
			}
			log.reportMessage(": "+t100);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv zone_size: 1<=zone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t104 = OCL.Set(self.getZone());
			IOclInteger t105 = (IOclInteger)t104.size();
			IOclBoolean t106 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t105);
			log.reportMessage(": "+t106);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv zone_bidirectional: zone->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t107 = OCL.Set(self.getZone());
			Zone x = null;
			IOclBoolean t108 = OCL.Boolean(true);
			java.util.Iterator t109 = OCL.impl(t107).iterator();
			while (t109.hasNext()) {
			    x = (Zone)t109.next();
			    Diagram t110 = (Diagram)x.getDiagram();
			    IOclBoolean t111 = OCL.equalTo(t110, self);
			    t108 = t111;
			    if(!OCL.impl(t108)) break;
			}
			log.reportMessage(": "+t108);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv arrow_size: 0<=arrow->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t112 = OCL.Set(self.getArrow());
			IOclInteger t113 = (IOclInteger)t112.size();
			IOclBoolean t114 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t113);
			log.reportMessage(": "+t114);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv arrow_bidirectional: arrow->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t115 = OCL.Set(self.getArrow());
			Arrow x = null;
			IOclBoolean t116 = OCL.Boolean(true);
			java.util.Iterator t117 = OCL.impl(t115).iterator();
			while (t117.hasNext()) {
			    x = (Arrow)t117.next();
			    Diagram t118 = (Diagram)x.getDiagram();
			    IOclBoolean t119 = OCL.equalTo(t118, self);
			    t116 = t119;
			    if(!OCL.impl(t116)) break;
			}
			log.reportMessage(": "+t116);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv collection_bidirectional: Set{collection}->forAll(x | x.region->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t120 = OCL.Set();
			Collection_ t121 = (Collection_)self.getCollection();
			t120 = t120.including(t121);
			Collection_ x = null;
			IOclBoolean t122 = OCL.Boolean(true);
			java.util.Iterator t123 = OCL.impl(t120).iterator();
			while (t123.hasNext()) {
			    x = (Collection_)t123.next();
			    IOclSet t124 = OCL.Set(x.getRegion());
			    IOclBoolean t125 = (IOclBoolean)t124.includes(self);
			    t122 = t125;
			    if(!OCL.impl(t122)) break;
			}
			log.reportMessage(": "+t122);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv contour_bidirectional: contour.basicRegion=self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Contour t126 = (Contour)self.getContour();
			Region t127 = (Region)t126.getBasicRegion();
			IOclBoolean t128 = OCL.equalTo(t127, self);
			log.reportMessage(": "+t128);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv containedZone_size: 0<=containedZone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t129 = OCL.Set(self.getContainedZone());
			IOclInteger t130 = (IOclInteger)t129.size();
			IOclBoolean t131 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t130);
			log.reportMessage(": "+t131);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv containedZone_bidirectional: containedZone->forAll(x | x.containingRegion->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t132 = OCL.Set(self.getContainedZone());
			Zone x = null;
			IOclBoolean t133 = OCL.Boolean(true);
			java.util.Iterator t134 = OCL.impl(t132).iterator();
			while (t134.hasNext()) {
			    x = (Zone)t134.next();
			    IOclSet t135 = OCL.Set(x.getContainingRegion());
			    IOclBoolean t136 = (IOclBoolean)t135.includes(self);
			    t133 = t136;
			    if(!OCL.impl(t133)) break;
			}
			log.reportMessage(": "+t133);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.SpiderKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.SpiderKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv collection_bidirectional: Set{collection}->forAll(x | x.region->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t137 = OCL.Set();
			Collection_ t138 = (Collection_)self.getCollection();
			t137 = t137.including(t138);
			Collection_ x = null;
			IOclBoolean t139 = OCL.Boolean(true);
			java.util.Iterator t140 = OCL.impl(t137).iterator();
			while (t140.hasNext()) {
			    x = (Collection_)t140.next();
			    IOclSet t141 = OCL.Set(x.getRegion());
			    IOclBoolean t142 = (IOclBoolean)t141.includes(self);
			    t139 = t142;
			    if(!OCL.impl(t139)) break;
			}
			log.reportMessage(": "+t139);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv contour_bidirectional: contour.basicRegion=self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Contour t143 = (Contour)self.getContour();
			Region t144 = (Region)t143.getBasicRegion();
			IOclBoolean t145 = OCL.equalTo(t144, self);
			log.reportMessage(": "+t145);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containedZone_size: 0<=containedZone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t146 = OCL.Set(self.getContainedZone());
			IOclInteger t147 = (IOclInteger)t146.size();
			IOclBoolean t148 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t147);
			log.reportMessage(": "+t148);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containedZone_bidirectional: containedZone->forAll(x | x.containingRegion->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t149 = OCL.Set(self.getContainedZone());
			Zone x = null;
			IOclBoolean t150 = OCL.Boolean(true);
			java.util.Iterator t151 = OCL.impl(t149).iterator();
			while (t151.hasNext()) {
			    x = (Zone)t151.next();
			    IOclSet t152 = OCL.Set(x.getContainingRegion());
			    IOclBoolean t153 = (IOclBoolean)t152.includes(self);
			    t150 = t153;
			    if(!OCL.impl(t150)) break;
			}
			log.reportMessage(": "+t150);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingContour_size: 0<=containingContour->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t154 = OCL.Set(self.getContainingContour());
			IOclInteger t155 = (IOclInteger)t154.size();
			IOclBoolean t156 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t155);
			log.reportMessage(": "+t156);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingRegion_size: 1<=containingRegion->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t157 = OCL.Set(self.getContainingRegion());
			IOclInteger t158 = (IOclInteger)t157.size();
			IOclBoolean t159 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t158);
			log.reportMessage(": "+t159);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingRegion_bidirectional: containingRegion->forAll(x | x.containedZone->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t160 = OCL.Set(self.getContainingRegion());
			Region x = null;
			IOclBoolean t161 = OCL.Boolean(true);
			java.util.Iterator t162 = OCL.impl(t160).iterator();
			while (t162.hasNext()) {
			    x = (Region)t162.next();
			    IOclSet t163 = OCL.Set(x.getContainedZone());
			    IOclBoolean t164 = (IOclBoolean)t163.includes(self);
			    t161 = t164;
			    if(!OCL.impl(t161)) break;
			}
			log.reportMessage(": "+t161);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv diagram_bidirectional: Set{diagram}->forAll(x | x.zone->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t165 = OCL.Set();
			Diagram t166 = (Diagram)self.getDiagram();
			t165 = t165.including(t166);
			Diagram x = null;
			IOclBoolean t167 = OCL.Boolean(true);
			java.util.Iterator t168 = OCL.impl(t165).iterator();
			while (t168.hasNext()) {
			    x = (Diagram)t168.next();
			    IOclSet t169 = OCL.Set(x.getZone());
			    IOclBoolean t170 = (IOclBoolean)t169.includes(self);
			    t167 = t170;
			    if(!OCL.impl(t167)) break;
			}
			log.reportMessage(": "+t167);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.CollectionKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.CollectionKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Contour inv basicRegion_bidirectional: basicRegion.contour = self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Region t171 = (Region)self.getBasicRegion();
			Contour t172 = (Contour)t171.getContour();
			IOclBoolean t173 = OCL.equalTo(t172, self);
			log.reportMessage(": "+t173);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Contour inv diagram_bidirectional: Set{diagram}->forAll(x | x.contour->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t174 = OCL.Set();
			Diagram t175 = (Diagram)self.getDiagram();
			t174 = t174.including(t175);
			Diagram x = null;
			IOclBoolean t176 = OCL.Boolean(true);
			java.util.Iterator t177 = OCL.impl(t174).iterator();
			while (t177.hasNext()) {
			    x = (Diagram)t177.next();
			    IOclSet t178 = OCL.Set(x.getContour());
			    IOclBoolean t179 = (IOclBoolean)t178.includes(self);
			    t176 = t179;
			    if(!OCL.impl(t176)) break;
			}
			log.reportMessage(": "+t176);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
}
